# $Id$
w('static void print_%s(void *user_data', func.name)
if ret.ctype!="void":
	w(', %s ret', ret.ctype)
for p in params:
	w(', %s %s', p.ctype, p.name)
wl(')')
wl('{')
wl('	GlPrintData *gpd = (GlPrintData *)user_data;')
w('	snprintf(gpd->buffer, gpd->bufsize, "%s(', func.name)
first = True
for p in params:
	if not first:
		w(', ')
	if p.kind=="value":
		w('%s', p.io[1])
	elif p.kind=="reference":
		if p.io:
			w('{%s}', p.io[1])
		else:
			w('<ref:%s %%p>', p.type)
	elif p.kind=="array":
		w('%%s')
	first = False
w(')')
if ret.ctype!="void":
	w(' = %s', ret.io[1])
w('"')
for p in params+[ret]:
	if p.ctype!="void":
		if p.kind=="value":
			if len(p.io)>=3 and p.io[2]:
				f = p.io[2].split(':')
				w(', %s(%s)', f[0], ", ".join(eval(x) for x in f[1:]))
			else:
				w(', %s', p.name)
		elif p.kind=="reference":
			if p.io:
				w(', *%s', p.name)
			else:
				w(', %s', p.name)
		elif p.kind=="array":
			if not p.csize:
				w(', print_data(%s, 0)', p.name)
			elif p.base_ctype=="GLvoid" or p.base_ctype=="void":
				w(', print_data(%s, %s)', p.name, p.csize)
			else:
				f = p.io[1]
				if len(p.io)>=3 and p.io[2]:
					f = "%x"
				w(', print_array("%s", %s, sizeof(%s), %s)', f, p.name, p.base_ctype, p.csize)
wl(');')
wl('}')
:static void init_print(GlDecoder *dec)
:{
wl('	dec->%s = print_%s;', func.name, func.name)
:}
