/* $Id$

This file is part of gldbg
Copyright © 2009-2010  Mikko Rasa, Mikkosoft Productions
Distributed under the GPL
*/

#ifndef TRACER_H_
#define TRACER_H_

#include <msp/io/base.h>
#include "tool.h"

struct GlPrint;

class Tracer: public RegisteredTool<Tracer>
{
private:
	GlPrint *glprint;
	Msp::IO::Base *out;
	bool delete_out;
	bool enabled;

public:
	Tracer(GlDbg &);
	~Tracer();

	virtual void decode(const char *, unsigned);
private:
	void set_output(Msp::IO::Base *, bool);
	void cmd_trace(const std::string &);
};

#endif
